NEWS
====

------------------------------------------
0.7.5 (to be announced) "pulsating plasma"
------------------------------------------

- A bunch of build system improvements and cleanups.
- The special argument '-' to the select subcommand now reactivates
  the previous mood or playlist.

Download:
[tarball](./releases/paraslash-git.tar.xz)

----------------------------------------
0.7.4 (2025-01-08) "genetic contraction"
----------------------------------------

Modernization of the openssl code and faster mp3 decoding are the
main features of this release. On top of the few other user-visible
changes listed below there is the usual mix of bug fixes and internal
improvements. As always, the git log has all the details.

- The openssl RSA code has been converted to EVP and no longer uses
  any deprecated openssl API functions.
- Simplification of the build system. The only visible effect is
  that configure no longer prints a summary at the end.
- para_play is no longer built if libreadline is not installed.
- Speedups for the buffer tree code, which particularly improves the
  performance of para_play for large mp3 files.
- The chunk table and mbox listing modes of the ls server command
  have been deprecated. They still work, but a warning is issued to
  inform the user about the deprecated option.
- The alsa writer also supports 32 bit float sample formats.
- The project no longer releases maintenance versions. The "maint"
  integration branch has been removed from the git repository.

Downloads:
[tarball](./releases/paraslash-0.7.4.tar.xz),
[signature](./releases/paraslash-0.7.4.tar.xz.asc)

----------------------------------------
0.6.5 (2024-12-01) "chaotic scalability"
----------------------------------------

Quite a few bugs were found since paraslash-0.6.4 was released in
2021-11, so here is another maintenance release for the 0.6 series. No
new features but lots of fixes. This is going to be the last 0.6.x
release, and all users are expected to upgrade to 0.7.x.

- Fix the -c option of the server ls command.
- server: Don't crash if the empty string is passed as a mood name.
- server: Fix another crash when attempting to reposition the stream
  while no audio file is open.
- server: Close a race window which leads to a deadlock when a signal
  arrives just at the right time.
- server: Close another race window which caused delayed status updates
  in certain cases.
- server/gcrypt: Reject short RSA keys up-front.
- para_play: Don't abort if too many invalid keys are pressed.
- Plug some memory leaks.

Downloads:
[tarball](./releases/paraslash-0.6.5.tar.xz),
[signature](./releases/paraslash-0.6.5.tar.xz.asc)

-----------------------------------------
0.7.3 (2024-03-12) "weighted correctness"
-----------------------------------------

The highlight of this release is the new "ls --admissible=m/foo"
feature described below. Other user-visible changes include minor
additions to the "ls" and "select" server commands. The release also
includes a fair number of cleanups for the crypto code and the file
descriptor utilities, both without visible effects. Old ssh keys
and outdated openssl library versions are now deprecated and cause
warnings.

- Old style PEM keys are now deprecated. They still work but their
  use results in a run-time warning. The removal of PEM key support is
  scheduled for paraslash-0.8.0.
- Version 1.0 of the openssl library has been deprecated. A warning
  is printed at compile-time on systems which have this outdated version
  because it will no longer be supported once paraslash-0.8.0 comes out.
- A spring cleanup for the senescent code in fd.c.
- The --admissible option of the ls command now takes an optional
  argument. When invoked like --admissible=m/foo, only files which are
  admissible with respect to mood foo are listed.
- The select server command is now quiet by default, The new --verbose
  option can be used to show information about the newly loaded mood
  or playlist.
- The ls server command gained the --limit option to force a limit
  on the number of files listed.
- Cleanup of the openssl-specific code.

Downloads:
[tarball](./releases/paraslash-0.7.3.tar.xz),
[signature](./releases/paraslash-0.7.3.tar.xz.asc)

-------------------------------------
0.7.2 (2023-03-08) "optical friction"
-------------------------------------

The improved error reporting of afs commands and the two new options
for the sleep subcommand of para_mixer are the most prominent features
of this minor release. The bulk of the changes are cleanups of the
afs and net subsystems, which should both have no user-visible impact.

- A major cleanup of the audio file selector.
- The client no longer prints error messages from afs commands to
  stdout but to stderr.
- The sleep subcommand of para_mixer gained two options to control
  the startup mood and the time period before fade-out starts. A bunch
  of further improvements for this subcommand went in as well.
- Minor cleanup of the net subsystem.
- The openssl specific code now employs the EVP API to compute hashes.
  It should compile without warnings against openssl-3.
- The deprecated syntax for specifying negative offsets in the argument
  to the "ff" server command has been removed.

Downloads:
[tarball](./releases/paraslash-0.7.2.tar.xz),
[signature](./releases/paraslash-0.7.2.tar.xz.asc)

--------------------------------------
0.7.1 (2022-10-03) "digital spindrift"
--------------------------------------

The two new ll commands and the internal mp4ff library are the most
user-visible changes of this release. On top of that there are two
core changes which aim to improve the robustness of the code but which
are otherwise invisible: the switch from select(2) to poll(2) and the
revised memory allocation API which checks for integer overflows. The
release also comes with a slight change to the build system and the
usual mix of bug fixes and minor improvements not mentioned here.

- The autogen.sh script now only creates the autoconf specific files
  but no longer runs configure, make and the test suite.
- A stripped down copy of the discontinued libmp4ff library has become
  part of the paraslash code base. As a result it is no longer necessary
  to install faad from source to get support for aac/m4a files. The
  faad decoder package must still be installed.
- The log level of the running daemon can now be changed with the
  new ll command. It is available for para_server and para_audiod.
- All calls to select(2) have been replaced by calls to poll(2)
  to avoid known shortcomings of the select API.
- All allocation functions now check for integer overflow. Since this
  requires support from the compiler, the oldest supported gcc version
  has been bumped to gcc-5.4 (released in 2015).

Downloads:
[tarball](./releases/paraslash-0.7.1.tar.xz),
[signature](./releases/paraslash-0.7.1.tar.xz.asc)

----------------------------------
0.7.0 (2022-03-12) "seismic orbit"
----------------------------------

The major incompatible change which requires to bump the major version
is the switch from sha1 to sha256, see below for details. However,
there are many other improvements, the usual amount of bug fixes and
a couple of new features.

- Starting with paraslash-0.7.0, the sha256 hash value of each known
  audio file is stored in the database while older versions employed the
  sha1 hash algorithm which has been considered insecure since 2005
  and should no longer be used today. The switch from sha1 to sha256
  requires users to upgrade their database using the new para_upgrade_db
  program, followed by re-adding all files to recompute the hashes. With
  this approach all metadata stored in the database (last played date,
  num played value, moods, playlists, attributes etc.) are kept. An
  simpler alternative is to start over from scratch by running the
  "init" command but this will lose these metadata.
- Server and client now hash the session keys with sha256 rather
  than sha1 during the initial handshake. This feature is optional and
  backwards compatible: old clients can still connect to a new server
  (using sha1). Also new clients can connect to an old server (again
  using sha1).
- The new "duration" keyword of the mood grammar makes it possible to
  impose a constraint on the duration of the admissible files.
- The long deprecated version 1 mood syntax is no longer supported.
- Paraslash writers handle early end-of-file more gracefully.
- The alsa writer no longer warns about spurious underruns.
- The score formula  of the audio file selector has been reworked.
- Cleanups of the doubly linked lists code.
- New option for configure: --enable-ubsan to detect and report undefined
  behaviour.
- The "tasks" server command has been removed.
- The fancy new logo and a minor overhaul of the web pages.

Downloads:
[tarball](./releases/paraslash-0.7.0.tar.xz),
[signature](./releases/paraslash-0.7.0.tar.xz.asc)

--------------------------------------
0.6.4 (2021-11-04) "fuzzy calibration"
--------------------------------------

This point release contains a fair number of fixes but no new features.
This marks the end of the 0.6 development, although paraslash-0.6 will
still be supported for some time and subsequent maintenance releases
may follow.

- The udp sender no longer crashes when empty chunks are encountered.
- Fix a double-free bug in the exit path of the server.
- The "jmp" command now errors out when given a negative percentage.
- A fix for a bug in para_afh which triggered on the attempt to modify
  the tags of an invalid mp4 file.
- A memory leak in para_afh has been fixed.
- The udp sender no longer sends multiple EOF packets.
- Some gcc warnings have been silenced.
- Minor log level adjustments and documentation improvements.

Downloads:
[tarball](./releases/paraslash-0.6.4.tar.xz),
[signature](./releases/paraslash-0.6.4.tar.xz.asc)

---------------------------------------
0.5.9 (2021-11-04) "reversed dimension"
---------------------------------------

This release contains a few important fixes which have accumulated in
the maint branch. The paraslash-0.5.x series has now reached its end
of life and will no longer be supported. All users should upgrade to
a more recent version at this point.

- Fix an issue with the bash completion script.
- Initialize the random seed also when using libgrypt.
- Fix some compiler warnings in the resample filter
- Don't return spurious errors from the ff server command.

Downloads:
[tarball](./releases/paraslash-0.5.9.tar.bz2),
[signature](./releases/paraslash-0.5.9.tar.bz2.asc)

----------------------------------------
0.6.3 (2021-02-18) "generalized activity"
-----------------------------------------

It has been a while since the last release, but paraslash-0.6.3
finally has arrived. It contains a fair number of improvements,
features and fixes all over the place.

- The ff command now accepts a negative argument to instruct the
  virtual streaming system to jump backwards in the current audio
  stream. The old syntax (e.g., "ff 30-") is still supported but it
  is deprecated and no longer documented. The compatibility code is
  sheduled for removal after 0.7.0.
- para_afh: New option: --preserve to reset the modification time to
  the value of the original file after meta data modification.
- Overhaul of the compress filter code. The refined algorithm should
  reduce clipping. The meaning of --aggressiveness has changed, see the
  updated and extended documentation of the compress filter for details.
- Cleanup of the audio format handler code.
- We now build the tree using the .ONESHELL feature of GNU make,
  which results in a significant speedup.
- Two robustness fixes for FreeBSD.
- para_client now supports RFC4716 private keys as generated with
  ssh-keygen -m RFC4716. In fact, this key format has been made the
  default, and the former PEM keys will be depreciated at some point.
- The ogg audio format handlers learned to detect holes and now report
  the correct duration also if ogg pages are missing in the file. This
  affects ogg/vorbis ogg/speex and ogg/opus.
- Robustness improvements for para_mixer.
- A fix for an old bug that could cause the server to crash or report
  garbage in its status output.
- New para_play option: --end-of-playlist
- Streaming m4a files over udp has been improved.

Downloads:
[tarball](./releases/paraslash-0.6.3.tar.xz),
[signature](./releases/paraslash-0.6.3.tar.xz.asc)

--------------------------------------
0.6.2 (2018-06-30) "elastic diversity"
--------------------------------------

The main new feature of this release is the --listen-address option
for para_server and para_audiod. But there are also a large number of
small improvements and bug fixes all over the place. The user-visible
changes include

- para_gui no longer waits up to one second to update the screen when
  the geometry of the terminal changes.
- Minor documentation improvements.
- Improvements to the crypto subsystem.
- The server subcommand "task" has been deprecated. It still works,
  but prints nothing. It will be removed in the next major release.
- Server log output is now serialized, avoiding issues with partial
  lines.
- It is now possible to switch to a different afs database by changing
  the server configuration and sending SIGHUP to the server process.
- New server options: --listen--address, --http-listen-address and
  --dccp-listen-address. These options restrict the set of listening
  addresses of the TCP and DCCP sockets of the server process.
- The help commands of server, audiod, play now support --long. By default,
  the short help is shown.
- The code which merges the command line options with the config file
  options has been consolidated.
- If the current audio file is renamed, the status items are now updated
  accordingly.
- After the server process received SIGHUP, changes to the current audio
  file did not trigger an update of the status items. This has been fixed.

Downloads:
[tarball](./releases/paraslash-0.6.2.tar.xz),
[signature](./releases/paraslash-0.6.2.tar.xz.asc)

----------------------------------------
0.6.1 (2017-09-23) "segmented iteration"
----------------------------------------

The highlight of this release is the version 2 mood parser. But there
is a lot more than that, as summarized in the list below. And of
course we have many small usability improvements and bug fixes not
mentioned here.

- A more intuitive syntax for moods ("version 2 moods"). The
  traditional version 1 moods are still supported but are deprecated
  now. Removal of the version 1 mood parser is scheduled for the next
  major release.
- Flex and bison are now required to build para_server.
- New sort order for the ls command: -s=h sorts the ls output by hash
  value of the audio file.
- autogen.sh now runs the test suite after a successful build.
- The contents of overview.pdf have been integrated into the user
  manual.
- Fixed sized audio format headers for ogg/opus streams.
- The doxygen source browser has been disabled temporarily. The
  API reference is still online, though.
- Overhaul of the source code documentation.
- The deprecated --full-path option of the ls command has been
  removed. It was a no-op since 0.6.0.
- The wma decoder has been cleaned up and its bitstream API made
  more robust.
- The image/lyrics ID status items of the current audio file are now
  updated on changes. This affects para_gui, which used to report the
  old value until EOF.

Downloads:
[tarball](./releases/paraslash-0.6.1.tar.xz),
[signature](./releases/paraslash-0.6.1.tar.xz.asc)

---------------------------------------
0.5.9 (2021-11-04) "reversed dimension"
---------------------------------------
This release contains a few important fixes which have accumulated in
the maint branch. The paraslash-0.5.x series has now reached its end
of life and will no longer be supported. All users should upgrade to
a more recent version at this point.

- Fix an issue with the bash completion script.
- Initialize the random seed also when using libgrypt.
- Fix some compiler warnings in the resample filter
- Don't return spurious errors from the ff server command.

Downloads:
[tarball](./releases/paraslash-0.5.9.tar.bz2),
[signature](./releases/paraslash-0.5.9.tar.bz2.asc)

---------------------------------------
0.5.8 (2017-09-23) "branching parabola"
---------------------------------------

A couple of fixes for serious old bugs have accummulated in the maint
branch since paraslash-0.5.7 was released nine months ago. So here
is another 0.5.x release. As usual, all commits in the maint branch
have been merged into master, so the upcoming paraslash-0.6.1 also
contains them. For details see the git log.

Downloads:
[tarball](./releases/paraslash-0.5.8.tar.bz2),
[signature](./releases/paraslash-0.5.8.tar.bz2.asc)

-------------------------------
0.6.0 (2017-04-28) "fuzzy flux"
-------------------------------

The highlights of this release are the conversion of all option parsers
to the lopsub library and the improved AAC support. But there are
many other user-visible changes all over the place. Also a lot of
old cruft has been removed, leading to incompatible changes. Hence
the new major version number.

- Support for Mac OS X has been removed.
- On Linux systems, glibc-2.17 or newer is required to build the
  source tree.
- Support for RSA public keys in ASN format (as generated by openssl
  genrsa) has been removed. These keys have been deprecated since
  2011, so users should have long switched to keys generated with
  ssh-keygen(1).
- If libgcrypt is used as the crypto library, we now require version
  1.5.0 (released in 2011) or later.
- The insecure RC4 stream cipher has been removed. It was superseded
  by aes_ctr128 three years ago but the RC4 code had been kept for
  backwards compatibility.
- On Linux, abstract unix domain sockets are used unconditionally.
- The "install" target no longer strips executables, the new
  install-strip target can be used to get the old behaviour.
- The clean targets have been renamed: clean2 is gone, and the new
  mostlyclean removes only the executables and object files.
- New target: check (identical to test).
- The DESTDIR make variable is honored to prepend a path to the
  installation directory. This feature is orthogonal to the --prefix
  option to configure.
- Minor WMA cleanups.
- The aac audio format handler has been rewritten to use the mp4ff library.
  See the manual for how to install the library on your system.
- New status item: max_chunk_size. The value is stored in a previously
  unused field of the afhi object of the aft table. Although backwards
  compatible, users are encouraged to re-add m4a files to populate
  the new field.
- No more chunk tables for aac. Chunk boundaries are determined
  dynamically at stream time.
- Release and master branch tarballs are now compressed with xz rather
  than bzip2.
- The lopsub package is required to install the paraslash package.
  Gengetopt is no longer needed.
- make dep is gone. Dependencies have been created automatically for
  a long time and it was never necessary to run make dep manually.
- para_gui lost its --timeout option.
- Most manual pages have been extended to include an overall
  description of the command.
- The --stream-delay option of para_audiod has been removed. It had
  been a no-op for many years.
- The deprecated --path option of the server ls command has been
  removed.  The command now prints full paths by default, making
  --full-path a no-op. Hence --full-path has been depreacted and is
  scheduled for removal in v0.6.1.
- It is now possible to use 'CFLAGS' to override the default compiler
  options.
- para_fade has been renamed to para_mixer. The four modes of operation
  (set, fade, snooze, sleep) are implemented as subcommands of the
  new program.
- The sleep subcommand of para_mixer (former sleep mode of para_fade)
  lost its --wake-hour and --wake-min options in favor of the new
  --wake-time option which also accepts relative wakeup times like
  "+9:30".
- The new --fade-exponent option of para_mixer allows for non-linear
  channel fading.
- The new logo.

Downloads:
[tarball](./releases/paraslash-0.6.0.tar.xz),
[signature](./releases/paraslash-0.6.0.tar.xz.asc)

-------------------------------------
0.5.7 (2016-12-31) "semantic density"
-------------------------------------

Mostly a bug fix release, and a bunch of internal improvements.
The only user-visible changes are the sanity checks for the touch
command and the new options to the ls command.

- Speedup of the base64 decoder.
- One of the two source browsers has been removed from the web pages.
  The doxygen API reference still contains an HTML version of each
  source file.
- Two race conditions in para_server have been fixed.
- ls -p is now deprecated in favor of -F or -b. See the help text of
  the ls command for details.
- The openssl code has been adjusted to work also with openssl-1.1.
- The wma decoder and audio format handler now correctly decodes
  files with unusual block sizes.
- We now compile with -Wformat-signedness if possible.
- The touch command now refuses to set an invalid image or lyrics ID.
- New section on contributing for the user manual.
- Major simplification of the error subsystem.

Downloads:
[tarball](./releases/paraslash-0.5.7.tar.bz2),
[signature](./releases/paraslash-0.5.7.tar.bz2.asc)

-------------------------------------------
0.4.14 (2016-12-31) "branching oscillation"
-------------------------------------------

Many fixes for nasty bugs have accumulated over the years since 0.4.13
was released in 2013. This release contains all of them. It is the
last v0.4.x release, so v0.4.x is now end of life. The maint branch
of the git repository has been forwarded to v0.5.7 and will start to
receive important fixes for 0.5.x, which is now in maintenance mode.

- Fix for the "double encryption bug" with gcrypt, which caused
  garbage to be sent to stat clients.
- The "prev" command of para_play now works as expected.
- Invalid parameters for the begin and end chunk no longer cause
  the afh receiver of para_recv to segfault.
- A fix for an assertion that triggered in the FEC slice setup code.
- Closing the terminal with a running para_gui causes the process to
  die, rather than using 100% of CPU time.
- para_gui no longer shows stale information about the previous
  audio file.
- A fix for a bug in the fec decoder which caused aborts if the buffer
  pool filled up.
- The assertion in the buffer tree code no longer triggers.
- The "afs_event: table moods, event 0: key already exists in rbtree"
  error no longer occurs on attribute changes.
- A NULL pointer dereference in com_sender() has been fixed.
- The -i option of lsatt works as advertised.
- Various fixes for the build system.

Downloads:
[tarball](./releases/paraslash-0.4.14.tar.bz2),
[signature](./releases/paraslash-0.4.14.tar.bz2.asc)

---------------------------------------
0.5.6 (2016-07-10) "cascading gradient"
---------------------------------------

The highlight of this release is the new -m flag for para_afh which
lets it modify the meta tags of the given audio file(s). This feature
is supported for all audio formats. Many small cleanups and bug fixes
not mentioned here have accumulated and are also part of the release.

- para_afh learned to modify meta tags of mp3 wma ogg spx
  opus flac aac files.
- afs commands propagate error codes to the client.
- The check command now also checks the attribute table for
  inconsistencies.
- New -v flag for the version command (print verbose version string)
- New option --priority for para_server and para_audiod.
- New mood methods: image_id and lyrics_id.
- The manual and this NEWS file have been converted to markdown.
- Support for the compile-time loglevel feature has been removed.
- Cleanup of the wma decoder and bitstream code.
- Improved wide-character support and fixes related to signal handling.
- para_gui no longer reports 100% playing time at the stream start.
- Opus cleanups.

Downloads:
[tarball](./releases/paraslash-0.5.6.tar.bz2),
[signature](./releases/paraslash-0.5.6.tar.bz2.asc)

--------------------------------------
0.5.5 (2015-09-20) "magnetic momentum"
--------------------------------------

Many new features and a lot of other improvements.

- On Linux systems, local sockets are now created in the
  abstract name space by default. This allows to get rid of
  the socket specials in /var/paraslash.
- The --user-allow option of para_audiod now accepts also
  usernames rather than only user IDs.
- New autoconf macros to avoid duplication in configure.ac.
- Status items (as shown by para_gui) are updated correctly
  when the meta information of the current audio changes.
- para_server and para_audiod no longer refuse to start in
  the background if no log file is given. Instead, all log
  messages go to /dev/null in this case.
- Web page cleanup.
- New syntax for the -l and -s options of the ls command.
  These options should now be specified as -l=v rather than
  -lv, for example. The old syntax still works, but support
  will be dropped in v0.6.0.

Downloads:
[tarball](./releases/paraslash-0.5.5.tar.bz2),
[signature](./releases/paraslash-0.5.5.tar.bz2.asc)

------------------------------------------
0.5.4 (2015-01-23) "exponential alignment"
------------------------------------------

Another cleanup and bugfix release.

- New server command: tasks.
- Minor cleanups to daemon.c.
- New URLs for home page and git services.
- Improved error diagnostics for the mvblob commands.
- New sender subcommand: status.
- Improved help text for server and afs commands.
- audiod memory leak fixes.
- Miscellaneous improvements to the build system.
- oss_writer improvements.
- Improved handling of mp3 files with both id3v1 and id3v2 tags.

Downloads:
[tarball](./releases/paraslash-0.5.4.tar.bz2),
[signature](./releases/paraslash-0.5.4.tar.bz2.asc)

---------------------------------------------
0.5.3 (2014-08-01) "symbolic synchronization"
---------------------------------------------

Not many new features, but lots of fixes and usability improvements.

- para_gui has been converted to use the paraslash scheduler.
- Various alsa-related fixes, mostly for the raspberry pi.
- Many scheduler improvements and cleanups.
- The test suite has been extended to include sanity checks
  for the generated man pages.
- ao_writer fixes. This writer was in a quite bad shape. Many
  serious bugs have been fixed.
- new audiod command: version.
- Minor improvements to the bitstream API.
- The cpsi command now prints a meaningful error message if
  none of the given patterns matched any audio file.

Downloads:
[tarball](./releases/paraslash-0.5.3.tar.bz2),
[signature](./releases/paraslash-0.5.3.tar.bz2.asc)

----------------------------------------
0.5.2 (2014-04-11) "orthogonal interior"
----------------------------------------

The new sync filter, the AES_CTR128 stream cipher and the overhauled
network code are the highlights of this release. It also includes a
fair number of smaller fixes and improvements not mentioned here.

- The new sync filter synchronizes playback between multiple
  clients.
- Connections between para_server and para_client are now
  encrypted by means of AES rather than RC4 if both sides
  support it. RC4 is still available as a fallback. This
  feature is fully transparent, i.e. no command line options
  are necessary, and a client linked against openssl can
  speak with a server linked against libgcrypt and vice versa.
- Major cleanup of the networking subsystem.
- Improvements to para_fade: the new set mode, multi-channel
  initial volumes, better error logging.
- The man pages of para_audiod, para_filter, para_recv, and
  para_write contain the relevant options for receivers, filters,
  writers. This broke in 0.5.0.
- ogg/vorbis latency improvements.
- Improved user manual.
- Minor fixes to avoid clang warnings.

Downloads:
[tarball](./releases/paraslash-0.5.2.tar.bz2),
[signature](./releases/paraslash-0.5.2.tar.bz2.asc)

------------------------------------------
0.5.1 (2013-12-20) "temporary implication"
------------------------------------------

Lots of fixes and improvements all over the place, and a major overhaul
of the build system.

- Audiod improvements and fixes.
- Buffer tree robustness improvements.
- Cleanup of the mood subsystem.
- Fixes and cleanups for the flac decoder.
- Latency improvements for the ogg/opus decoder.
- Crypto support is now optional. On systems without
  openssl/gcrypt, the build succeeds but para_server,
  para_audiod, para_client won't be built.
- The build system now works for cross-compile setups.
- The dependency tree has been flattened, which speeds up
  builds and avoids to recreate the man pages on every change.
- The error code helper has been rewritten from perl to C,
  which further improves build time.
- Many small bugs in the build system have been identified
  and fixed.

Downloads:
[tarball](./releases/paraslash-0.5.1.tar.bz2),
[signature](./releases/paraslash-0.5.1.tar.bz2.asc)

----------------------------------------
0.5.0 (2013-08-23) "invertible validity"
----------------------------------------

Some API-breaking changes, one serious bug fix, and a lot of bike-shedding.

- The sideband compatibility code has been removed, hence
  sideband connections (introduced in 0.4.11) are now mandatory.
- Addblob commands can produce output.
- The stat command no longer sends garbage when para_server was
  compiled against libgcrypt.
- Dependencies for gengetopt files are computed automatically.
  This eliminates a constant source of build bugs.
- The setatt command now accepts file name patterns rather than only
  path names.
- overview.pdf is now based on dia, a simple diagram creation program.
  The new version is much more detailed and contains descriptions of
  the various programs of the paraslash package.
- The separator of all multi-word options has been changed from
  underscore to dash. For example --log_color becomes --log-color.
- Overhauled web pages and the new logo.

Downloads:
[tarball](./releases/paraslash-0.5.0.tar.bz2),
[signature](./releases/paraslash-0.5.0.tar.bz2.asc)

--------------------------------------
0.4.13 (2013-07-29) "spectral gravity"
--------------------------------------

One more 0.4.x release before the API-breaking changes for 0.5.0 go
in. The main features of this release are the ogg/opus audio format,
and UTF-8 support, but it includes also tons of other improvements
and fixes all over the place.

- New audio format: ogg/opus.
- UTF8 support for para_gui and the mp3 audio format handler.
- Scheduler improvements and fixes.
- The obsolete gettimeofday() function has been replaced
  by clock_gettime() on systems which support it.
- Speed and usability improvements for para_gui.
- para_client now restores the fd flags of stdin and stdout
  on shutdown.
- Improved manual pages.
- Consistent version strings for all executables.
- Reduced dependencies on generated files result in fewer
  recompilations on changes.
- Performance improvements for the compress filter.
- Improved downloads web page.

-----------------------------------------
0.4.12 (2012-12-20) "volatile relativity"
-----------------------------------------
The new command line player, the resample filter, ALSA support for
para_fade, and the improved build system are the highlights of this
release which probably marks the end of the 0.4.x series.

- The afh receiver and the para_play executable.
- The resample filter: A sample rate converter based on
  libsamplerate.
- The "versions" directory has been removed from the master
  branch. The tarballs of the old releases are now available
  in the new "releases" branch.
- Overhaul of the build system: All generated files are now
  written to the "build" directory.
- The modular mixer API and the alsa mixer.
- Minor fixes for the osx writer.

--------------------------------------
0.4.11 (2012-07-20) "mutual diversity"
--------------------------------------

The major feature in this release is the new sideband API for
client-server communication. This API will be used exclusively starting
with 0.5.0, which breaks backward compatibility but allows to get rid
of quite some compatibility code. Other noteworthy changes include
decoder latency improvements and a long-standing bug fix for the
ALSA writer.

- Sideband connections: If both para_server and para_client
  support this feature, data is sent as a multiplexed stream.
- The --no_default_filters option of para_filter has been
  removed.
- Several fixes and latency improvements to various decoders.
- The ALSA writer now limits the prebuffer time to 500ms.
- Documentation improvements.
- Overhaul of the command_util.sh script.
- Fixes for some minor problems found by the clang analyzer.
- Compiles (almost) without warnings on gcc-3.
- Robustness improvements of the buffer tree code.

------------------------------------------
0.4.10 (2012-03-30) "heterogeneous vacuum"
------------------------------------------

Nothing earth-shaking in this release, but quite a few usability
improvements and the usual mix of cleanups and fixes.

- The --no_default_filters option of para_filter has been
  deprecated. It still works but has no effect and will be
  removed in the next version.
- para_gui now prints also the stderr output of the executing
  command in the bottom window.
- Cleanup and consolidation of the various wrappers for
  write(), writev(), send() and friends.
- The obscure error messages on mmap() failures have been
  replaced by meaningful messages. This affects mainly
  para_afh.
- para_audioc: Cleanups and memory leak fixes.
- Test 0004-server no longer fails if para_server is not
  being built.
- New configure options: --with-id3tag-{headers,libs}.

-------------------------------------
0.4.9 (2011-12-06) "hybrid causality"
-------------------------------------

Support for another audio format, interactive mode for para_client
and para_audiod and many small improvements/fixes all over the place.

- Support for flac, the free lossless audio codec.
- Fix for an endless loop in the mp3 decoder for certain
  (corrupt) mp3 files.
- When executed without specifying a command, para_client
  and para_audioc start an interactive shell (requires
  libreadline being installed). The interactive mode offers
  full tab completion and command line history.
- autogen.sh now detects a distcc setup and adjusts the
  parameter for the -j option of make accordingly.
- Shared memory areas are no longer restricted to 64K. We now
  detect the maximal size of a shared memory area at runtime.
- cleanup of the internal uptime API.
- para_server prefaults the mmapped audio file to avoid
  delays on slow media.
- A new test for the test-suite that exercises the
  communication between para_server and para_audiod.
- The alsa writer eats up less CPU cycles when configured to
  use the DMIX plugin.
- Simplified and unified receiver code.
- Makefile cleanups.
- Commands which print a list of matching audio files now
  emit a meaningful error message if no audio file matched the
  given pattern(s).

--------------------------------------
0.4.8 (2011-08-19) "nested assignment"
--------------------------------------

Gcrypt support, the overhauled osx writer and regex format specifiers
are the highlights of this release.

- support for libgcrypt as a drop-in replacement for openssl.
  Run configure --enable-cryptolib=gcrypt to link against
  libgcrypt. The two crypto implementations are compatible to
  each other, i.e. a para_client executable linked against
  gcrypt can connect to para_server linked against libssl
  and vice versa.
- Rewrite of the osx writer (output plugin for Mac OS).
- audiod: The format specifier for receivers, filters and
  writers is now treated as a regular expression. This allows
  to replace 5 lines in the config file (one for each audio
  format) by one single line. See the manual for details.
- The \*.cmdline.[ch] files are no longer contained in the released
  tarballs. This reduces the size of the tarballs but requires
  gengetopt to build the tarball.
- Compiles cleanly also with llvm/clang.
- Corrupt mp3 files are handled more gracefully.
- The alsa writer uses poll fds instead of computing timeouts.
- Cleanup of the generic writer API.
- sched: Optimized zero timeouts.
- vss timeout cleanups.
- oggdec fixes and improvements.

--------------------------------------
0.4.7 (2011-06-01) "infinite rollback"
--------------------------------------

The new ao writer, support for ssh RSA keys and a couple of other
enhancements.

- Support for ESD, Pulseaudio, AIX, Solaris, IRIX and other
  platforms through the libao audio library.
- Support for RSA keys generated with ssh-keygen.
- configure: improved options for ogg/vorbis/speex.
- The git version reported by --version always matches HEAD.
- The autogen script detects the number of processors and
  runs a parallel make if possible.
- Major cleanup of the crypto API.
- Documentation updates.

------------------------------------------
0.4.6 (2011-03-31) "deterministic entropy"
------------------------------------------

Lots of ogg/vorbis improvements, the new test suite, enhancements
for para_gui and a fair amount of other bug fixes.

- For DCCP/OGG streams the audio file header is only sent once
  at the beginning of the stream rather than periodically
  every five seconds. This reduces network traffic and the
  FEC group size.
- The vorbis comment header is replaced by an empty dummy header
  before the header is sent over the network. This also results in
  less network traffic and smaller FEC groups.
- The new "test" make target allows to perform some sanity checks prior
  to installing the package.
- ogg timing fixes and performance improvements
- Scheduler improvements
- Proper exit codes for para_write
- para_gui: New option --theme to select a startup theme. Several
  other improvements and fixes.
- aacdec error message cleanups
- simplified color error handling

--------------------------------------------
0.4.5 (2010-12-17) "symmetric randomization"
--------------------------------------------

Bug fixes, internal cleanups and variable-sized FEC slices.

- Contains a fix for an invalid-free-bug in the ogg audio format
  handler code.
- Switching off the DCCP sender works again.
- para_audiod handles crashes of para_server more robustly.
- Internal scheduler and writer cleanups.
- Reduced latency due to variable-sized FEC slices.
- Improved documentation and error diagnostics.
- The build of para_server is now optional, allowing the build
  to succeed in case libosl is not installed.

------------------------------------------
0.4.4 (2010-08-06) "persistent regularity"
------------------------------------------

Support for yet another audio format, para_write improvements and
bug fixes.

- Support for the speex codec.
- Support for sample formats other than 16 bit little endian.
- error2.h is now created by a perl script which speeds up configure
  considerably.
- Fix a bug in the aac decoder which could lead to segfaults in
  para_filter/para_audiod.
- Fixes for autoconf-2.66.

----------------------------------------
0.4.3 (2010-07-05) "imaginary radiation"
----------------------------------------

Many improvements for the DCCP and the UDP transport, the new user
manual and the usual mix of bug fixes and internal improvements.

- FEC support for the DCCP sender (Gerrit Renker). The new
  --dccp_max_slice_size, --dccp_data_slices_per_group and
  --dccp_slices_per_group options can be used to set the FEC
  parameters for the DCCP transport.
- DNS lookups for UDP targets (Gerrit Renker).
- The new user manual replaces the README, README.afs, REQUIREMENTS
  and INSTALL documents.
- Fix an end-of-file detection bug in the oggdec filter.
- The new nonblock API.
- Both options of the oggdec filter have been removed.
- New debug mode for the internal scheduler.

------------------------------------------
0.4.2 (2010-04-23) "associative expansion"
------------------------------------------

It's been some time since the last release, but finally here is
paraslash-0.4.2. The bulk of the changes comes from the new buffer
tree API, but there are changes all over the tree. Mainly performance
and usability improvements, but also quite some bug fixes.

- The new buffer tree API.
- DCCP: Support for CCID negotiation (Gerrit Renker).
- UDP robustness fixes.
- The --bufsize option for mp3dec is gone as it no longer makes sense
  for the new buffer tree API.
- Fix audible buffer underruns for wma streams.
- The alsa writer no longer prints meaningless underrun durations.
- audiod: Defaults work also for udp streams. If no filter is
  given for an audio format that is received via upd, fecdec is
  automatically added as the first filter (along with the decoder).

---------------------------------------
0.4.1 (2009-12-22) "concurrent horizon"
---------------------------------------

Support for another audio format, minor feature enhancements and lots of bug
fixes. All fixes that have been accumulated in the maint branch (in particular
those mentionened in the 0.3.6 release notes) appear in this release as well.

- wma support.
- new afh option: --human to activate human-readable output.
- new server/audiod option: --log-timing to print timing information.
- build system improvements.
- source code documentation updates.

-------------------------------------
0.3.6 (2009-12-07) "cubic continuity"
-------------------------------------

Quite a few bugs have been found and fixed since 0.3.5, so here's
another 0.3.x release. No new features.

- Always check return value of malloc().
- ogg vorbis/FEC: Do not write garbage after the audio file header.
- exit if root privileges could not be dropped.
- FEC: Fix computation of extra slices.
- oss: Fix check for empty input buffer.
- Avoid buffer underruns due to filter chain output buffer constraints.
- server: Fix assignment of afs_pid.
- Don't panic if the afs database contains unknown audio formats.
- http/dccp: Do not send the audio file header twice.
- FEC: Timing improvements.

----------------------------------------------
0.4.0 (2009-11-10) "simultaneous independence"
----------------------------------------------

Two significant changes which require the new version number: The
improved authentication dialog and the fact that the database code
has been moved to a library, libosl. To use the new version, you have
to generate new RSA keys, see INSTALL for details. A shell script is
provided for conversion of the 0.3 database to the new 0.4 format.

- stronger crypto for client authentication
- the database code has been moved to a library
- improved status item handling
- cleanup of the build system
- The "-V" option now also prints the git version
- the new parser-friendly listing mode for the ls and stat commands
- mandatory rc4 encryption
- major audio format handler cleanups
- (id3,...) tags are no longer stored as a combined string in the database
- new mood methods: artist_matches, title_matches, comment_matches,
  album_matches, year_maches, year.

--------------------------------------------
0.3.5 (2009-09-21) "symplectic separability"
--------------------------------------------

Full client support for \*BSD Unixes, complete re-write of the ogg
vorbis audio format handler, various improvements all over the place
and the usual mix of bugfixes. This release marks the end of the 0.3
series if no serious problems show up.

- the new oss writer (supported on \*BSD and Linux)
- rewrite of the ogg vorbis audio format handler. It's
  recommended to replace the chunk tables of existing ogg
  vorbis files in the afs database by re-adding these files
  with "add -f".
- support for netmask subsets (Gerrit Renker)
- the new prebuffer filter
- improved signal handling
- variable fec output buffer size
- improved FEC timing fixes audible buffer underruns in UDP mode
- --log_color actually works
- new ls option: -d (print dates as seconds after the epoch)
- update to gengetopt 2.22.2
- support for RSA keys of size > 512 bits
- new option "mixer_channel" for para_fade

-----------------------------------------
0.3.4 (2009-05-07) "elliptic inheritance"
-----------------------------------------

The new udp sender, forward error correction, colored logs and various
other improvements. As the udp sender does not depend on any special
libraries, it is built unconditionally.

- The udp sender replaces the ortp sender. The new code uses forward
  error correction to protect against packet losses. Many thanks to
  Gerrit Renker for providing ipv6 support.
- The default port for udp streaming now defaults to 8000, like
  for the http and the dccp senders/receivers.
- Loglevels are now specified as symbolic names, e.g.
  "--loglevel info".
- improved ipv4 and ipv6 URI parser (Gerrit Renker).
- para_server/para_audiod: Color support for log messages.
- new options for mp3dec: --ignore-crc, --bufsize
- new audiod option: --config-file.
- gengetopt cleanups.
- Improved help/man pages: The documentation of para_audiod,
  para_recv, para_filter and para_write now also contains
  all options of the available receivers/filters/writers. The
  man page of para_fade contains a description of the different
  modes of operation.
- More source code documentation.
- vss timing fixes.

--------------------------------------------
0.3.3 (2008-12-01) "axiomatic perspectivity"
--------------------------------------------

Internal code cleanups, bug fixes, improved tag handling and the new
amplification filter.

- para_server uses the generic scheduling code.
- overhaul of the virtual streaming system.
- mp3: id3 version 2 support via libid3tag (optional)
- ogg: vorbis comment support.
- aac meta info support.
- mp3 audio format handler cleanups.
- new filter: "amp" to amplify the amplitude of the audio stream
- new status item/database entry: amplification. It is
  used by the amp filter to pre-amplify the audio stream.
- fix a close-without-open bug in para_write.
- fix a bug in com_init() which was introduced in 0.3.2.
- better error diagnostics for para_client.

-----------------------------------------
0.3.2 (2008-04-11) "probabilistic parity"
-----------------------------------------

The new para_afh executable, scheduling and documentation improvements.

- new ls option: -lc (list chunk table)
- new executable: para_afh, the stand-alone audio file handler tool
- afs commands can send output more than SHMMAX (32MB on Linux). This
  also reduces the memory usage of commands that produce large amounts
  of output.
- major scheduler and audiod cleanups.
- more detailed and much nicer man pages.

---------------------------------------
0.3.1 (2008-02-23) "liquid interaction"
---------------------------------------

A mix of cleanups, bug fixes, improvements, and some new features. No
significant changes to the new database (osl) code, which is generally
a good sign.

- Share some similar/duplicate code between the http and the
  dccp sender.
- Generic access control lists for paraslash senders.
- dccp sender: Access control lists, connection limiting and support
  for the allow,deny,on,off,help sender commands.
- The default dccp port changed from 5001 to 8000 (suggested by
  Gerrit Renker).
- para_server starts even if not all public keys could be loaded.
- Audiod performance improvements.
- fix a bug in the "off" command of the http sender.
- fix some fd and memory leaks.
- Update to gengetopt-2.22.

-------------------------------------
0.3.0 (2008-01-12) "solar saturation"
-------------------------------------

paraslash.0.3.0 -- 'WWDBND --what would databases never do?'.


Usually one might expect lots of new features AND a big increase in size
for a major release like this.

However, paraslash-0.3.0.tar.bz2 is the smallest paraslash tarball
ever. The decrease in size is mostly due to the removal of some
graphical tools (which were only quick hacks anyway). But also the
fact that the mysql code is gone cuts down the size a bit.

Being independent of mysql comes at a cost: The fact that paraslash
now contains its own database (the object storage layer, osl) increases
the (stripped) binary size of para_server by ~50K on i386.

- no more restrictions on unique basenames.
- independent of mysql: The new self-contained object
  storage layer (osl) replaces the mysql database.
- New executable para_fsck: Check integrity of osl tables.
- Lyrics support.
- Reliable audio file move/rename detection.
- More portable than ever: Tested on Linux (x86_32, x86_64, sparc64),
  MacOS (ppc32, x86_32), FreeBSD (x86_32), NetBSD (x86_32) and
  Solaris (sparc64).
- the new osl-based audio file selector (afs) replaces the random,
  the playlist and the mysql selector of paraslash-0.2.x.
- IPv6 support (thanks to Gerrit Renker).
- paraslash-0.2.x streams are now called "moods". Writing
  0.3.x-mood definitions should be both easier and more
  powerful than writing 0.2.x-stream definitions.
- para_krell, para_slider, para_para_sdl_gui, para_dbadm have
  been removed. The world is a better place without them. However,
  para_gui is still there.
- afs tracks audio file selection also in playlist mode.
- few easy-to-use afs commands replace the many not-so-easy-to-use
  mysql commands (and are available also in playlist mode).
- Improved error subsystem.
- The earth-shaking new logo.

-----------------------------------------
0.2.17 (2007-11-20) "isotropic threshold"
-----------------------------------------

Mainly bugfixes and cleanups in this version which marks the end of
the 0.2.x series if no serious bugs show up after the release.

- mysql_selector: fix a locking bug.
- universal chunk queueing.
- dccp sender uses chunk queueing if write() returns EAGAIN (thanks
  to Gerrit Renker).
- be more carful wrt. signed vs. unsigned argument passing.
- cleanup error.h and fix some references to invalid error
  codes.
- update to gengetopt-2.21.
- update to ortp-0.13.1.
- autoconf: extend checks for headers, library functions and
  compiler characteristics.
- Fix streaming of large mp3 files.
- Fix an off-by-one bug in playlist handling.

--------------------------------------
0.2.16 (2007-04-05) "neural discharge"
--------------------------------------

The main change in this release is the major audio format handler
cleanup which removes some similar/duplicate code and makes it easier
to implement plugins for other audio formats. Of course, the usual mix
of other improvements/changes/bugfixes also made it into the release.

- simplified audio format handlers (most of the handling functions
  were moved one layer up to the virtual streaming system).
- para_server uses mmap to read audio files
- repositioning of mp3 streams is much faster, in particular for
  jumping near the end of large mp3 files.
- permission flags DB_READ,DB_WRITE have been renamed to AFS_READ
  and AFS_WRITE.
- fix a bug in para_filter that caused decoding of aac files
  to start only after a few seconds.
- fix osx_writer hangs
- simplified dccp code (thanks to Gerrit Renker)
- the compress filter works also on big endian systems (ppc)

-----------------------------------------
0.2.15 (2007-02-16) "inductive resonance"
-----------------------------------------

Minor improvements, more documentation and a bunch of bug fixes.

- para_server: The server.users file is only read once on server
  startup rather than for each connection
- mp3dec: Fix decoding of corrupt mp3 files
- afs (audio file sender) is now called vss (virtual streaming
  system). Consequently, the permission flags specified in
  ~/.paraslash/server.users have also changed: AFS_READ and AFS_WRITE
  become VSS_READ and VSS_WRITE respectively.
- para_audiod/para_filter: Fix a bug that caused the last chunk
  of audio data not being written under certain circumstances
- audiod: compute the difference of server time and local time
  correctly
- para_server/para_audiod: Fix some memory leaks
- documentation improvements
- configure.ac: fix checks for para_krell
- new man pages

-------------------------------------------
0.2.14 (2006-10-15) "transient singularity"
-------------------------------------------

The only major enhancement of this version is the osx writer which completes
the Mac OS Port and was originally planned already for 0.2.13 but had to wait
until now for reasons beyond the scope of this changelog entry.

- new output plugin for Mac Os: the osx writer
- rename configure command line options from --enable-xxx-headers to
  --with-xxx-headers and  --enable-xxx-libs to --with-xxx-libs
- configure: new command line options: --with-mad-headers,
  --with-mad-libs, --with-oggvorbis-headers, and --with-oggvorbis-libs
- some robustness fixes
- dymamic audio format recognition for audiod
- para_server: new command line option: --autoplay_delay
- para_audiod: new command line option: --clock_diff_count

---------------------------------------
0.2.13 (2006-07-14) "sonic convolution"
---------------------------------------

A bunch of new features and core changes.

- the new paraslash scheduler, short and sweet.
- Support for m4a/mp4 files via the new aac audio format
  handler/filter (requires libfaad).
- each writer has its own command line parser, just like
  para_recv and para_filter.
- para_client and para_audioc use the error subsystem
- writers are integrated in para_audiod (currently linux-only)
- para_client is integrated in para_audiod
- random/playlist selector: improved info strings
- new audiod commands: tasks, kill
- update to libortp-0.10.1
- para_fade: wake time defaults to 8 hours from now
- update to autoconf-2.60

------------------------------------------
0.2.12 (2006-05-12) "oriented abstraction"
------------------------------------------

Many user-visible changes in this release and lots of new
features:

- the new optional dccp sender/receiver. It uses the datagram
  congestion control protocol. You'll need a fairly new kernel
  for this.
- paraslash works on Mac OS X (thanks to Gerd Becker)
- para_play renamed to para_write
- modular output plugin design (writers) for para_write
- new file_writer output plugin for para_write
- compress filter speed improvements
- update to libortp-0.9.1
- update to gengetopt-2.17rc
- para_client no longer depends on libreadline (as the
  code for the interactive mode was removed).
- gcc-2-95 is no longer a supported compiler. It may still
  work, but it gets no more testing.
- the tarball no longer contains the screenshot images which
  reduces its size quite a bit.
- configure: new command line options: --enable-mysql-headers
  and --enable-mysql-libs

------------------------------------
0.2.11 (2006-03-11) "atomic duality"
------------------------------------

Here it is, the first paraslash release developed with git. There
are fairly many user-visible changes in this release. As two out of
the three "database tools" of paraslash don't use a database at all,
they are now called "audio file selectors" instead.

- the cdt command (change database tool) becomes chs (change
  selector)
- no more colon separators: The syntax of some options of
  para_audiod and para_filter have changed. Use --help for
  more info (and some examples).
- update to gengetopt-2.16 (thanks to Lorenzo Bettini)
- switch from cvs to git (should've done that earlier)
- the new ipc subsystem
- new audio file selector: playlist
- para_server: the dopey selector is now called "random",
  and is the default selector. Use the --selector option to
  choose another selector at startup, or the chs command to
  change the selector at runtime.
- X86_64 fixes (thanks to Steffen Klassert)
- para_play fixes

--------------------------------------
0.2.10 (2006-02-17) "cyclic attractor"
--------------------------------------

Huge documentation update, a scrollable window for para_gui, ortp
improvements, and of course many small fixes not mentioned here.
The diffstat below is rather misleading as most insertions are due
to the new source documentation.

- autoconf cleanup
- para_server also uses the new error subsystem
- lots of new documentation (UTSL)
- gui improvements:
	- keysyms for cursor keys and for next/previous page keys
	- scrollable output window
	- new internal commands: scroll up/down, page up/down
	- fix color of command output.
- ortp: the --chunk_time and --header flags are no longer needed
for para_recv/para_audiod as this information is now encoded in
each rtp packet sent by para_server.

-------------------------------------------
0.2.9 (2006-01-24) "progressive turbulence"
-------------------------------------------

Internal audiod receivers/filters, the new error subsystem and
a lot of small improvements.

- para_recv and para_filter are integrated into the para_audiod
  binary, i.e. audiod no longer spawns a new process for
  each receiver/filter. As para_recv and para_filter might be
  useful as standalone programs, they still get built (linked
  against the same object files that are also used for audiod).
- further ortp timing improvements should reduce the CPU usage
  of the ortp receiver.
- improved audio grabbing. The 'grab' command of para_audiod
  has its own set of command line options. Read the output of
  "para_audioc help grab" for more info.
- oggdec: configurable input prebuffer size.
- the new error subsystem gives better error diagnostics
  and reduces code size.

-----------------------------------------
0.2.8 (2006-01-02) "dynamic accumulation"
-----------------------------------------

The new modular filter design and the para_play-hangs bugfix.

- new executable: para_filter. It combines para_mp3dec,
  para_oggdec and para_compress. It also adds a further filter
  type, wav, that just inserts a wave header at the desired point
  of the filter chain. All 'piping' is done in-memory (i.e. no
  read/write operations are used).
- para_play: fix a stupid bug that caused it to hang under
  certain circumstances.

-------------------------------------------
0.2.7 (2006-12-27) "transparent invariance"
-------------------------------------------

Not many user-visible changes but a fair amount of internal improvements.

- The http sender buffers data if it can not be sent
  out immediately (because the socket is not writable). This
  should prevent para_server from shutting down the connection
  too early on a loaded network.
- para_play also prebuffers data if it is told to start at a
  future time by the --start_time option.
- The return of para_recv: It combines para_ortp_recv and
  para_http_recv. Use the --receiver option to switch between
  the two. para_recv builds without libortp, but contains
  only the http receiver in this case.
- update to ortp 0.8.1. As this ortp release contains incompatible
  changes, para_recv-0.2.7 won't link against older ortp libs.
- improved ortp timings.
- use of gcc-extensions that #define away for non-gcc and
  gcc < 3.0.

-------------------------------------------
0.2.6 (2005-10-29) "recursive compensation"
-------------------------------------------

Transparent session encryption (uses openssl's Alleged RC4 cipher),
the internal find command and several other improvements and cleanups.

- Encrypt the session if encryption is requested by the client
  (default for para_client 0.2.6). This is backwards
  compatible, so older clients can still connect to para_server
  0.2.6. Use the new client option --plain to request an
  uncrypted session (off by default, must be set to on in
  order to connect to para_server 0.2.x with 0 <= x <= 5).
- para_server uses an internal function to locate audio files
  rather than calling find(1). The server option
  --mysql_audio_file_dir replaces --mysql_find_cmd.
- documentation update
- man pages
- header file cleanup
- para_client code cleanup
- para_gui: faster display of output of display commands

------------------------------------------
0.2.5 (2005-10-13) "aggressive resolution"
------------------------------------------

This release adds internal senders, i.e. no more external programs are
spawned for sending out the audio data. There are two different senders
available: The http sender and the ortp sender (former para_send which
is no longer needed).

The new sender code has a plugin-like design so it can be easily
extended should there be be any future need for supporting another
network streaming protocol. All senders are completely independent of
each other. In particular, the http and the ortp sender can operate
in parallel.

- new server command: sender to control senders at runtime.
  Read the output of "para_server -h" and "para_client help
  sender" for more information.
- para_recv renamed to para_ortp_recv
- new executable: para_http_recv, a simple command line
  http receiver.
- major afs/mp3/ogg code simplifications due to internal
  senders.
- ogg timing improvements
- fix several minor memory leaks (found by valgrind)
- empty stream definitions work again
- com_ne(): ignore errors on remove
- audiod: fix segfault on server restart

---------------------------------------
0.2.4 (2005-09-21) "toxic anticipation"
---------------------------------------

Several small improvements, fixes and the new grab command.

- audiod:
	- new command: "grab" to grab the output of the stream reader
	  or any filters. Read the output of "para_audioc help grab"
	  for more information.
	- fix memory leak
	- code cleanup
- audioc: new command line option: --bufsize to specify a
  buffer size different from the default size 8192.
- improved error diagnostics for para_play.
- new configure option: --enable-ssldir so search for openssl in
  non-standard places
- sdl_gui: Make it look nice again for 1024x768
- server: report total size of memory allocated with sbrk by malloc,
  new command line option: --announce_time

-----------------------------------------
0.2.3 (2005-09-01) "hydrophilic movement"
-----------------------------------------

Two new executables and major feature enhancements.

- audiod filters: It is now possible to specify arbitrary many
  (including none) filters for each supported audio
  format. This can be used e.g. for normalizing volume,
  transforming or grabbing the audio stream, or for using
  visualizers.	Read the output of "para_audiod -h" for the
  syntax of the new --filter_cmd option.
- new executable: para_play, a tiny alsa player. It
  can play wave files or raw pcm (16 bit little endian)
  from stdin.
- new executable: para_compress, a dynamic range compressor
  intended to keep audio output at a consistent volume. Derived
  from [AudioCompress](http://trikuare.cx/code/AudioCompress.html).
- audiod: New option: --stream_delay. This can be used in
  a local network to syncronize the audio output of all
  clients that play the same stream.

------------------------------------------
0.2.2 (2005-08-19) "tangential excitation"
------------------------------------------

Mostly internal changes in this release, but also some new commands
for the mysql database tool.

- cleanup exec.c, fix para_exec bug
- compile time loglevel (log messages below the given level
  won't be compiled in, which reduces the size of the
  resulting binaries)
- new log macros that shorten the size of the source code.
- workaround a gcc-4.1 bug (?) that caused send_cred_buffer()
  to send only zeros. With this workaround, para_audioc works
  again.
- avoid gcc-4 warning: conflicting types for built-in function 'clog'
- new mysql commands: "rm" (remove entry), "mv" (rename entry) "ne"
  (new entry), "snp" (set numplayed). Read the manual for more
  information.

---------------------------------------
0.2.1 (2005-08-15) "surreal experience"
---------------------------------------

Here comes paraslash-0.2.1. It contains a couple of new features and,
surprise, only minor bug fixes.

- kill noisy mp3 debug message
- cleanup of the build system
- para_server and para_client directly use the crypto routines
  of the openssl library rather than invoking the openssl command
  line utitlity
- server/audiod: new option --user to switch to the given user
  when invoked as root. Read the output of "para_server -h" for
  more information.
- gui/sdl_gui: new option --stat_cmd to be used to retrieve the
  status. Default: "para_audioc stat"
- sdl_gui: new option --pic_cmd to be used to download the picture.
  Default: "para_client pic"
- audiod: 5 slots ought to be enough for everybody
- audiod: new status item: Uptime, kill hup command

------------------------------------------
0.2.0 (2005-08-06) "distributed diffusion"
------------------------------------------

After several month of increased development activity, paraslash-0.2.0
has arrived. It contains many new features and is much more
self-contained than the old 0.1.x series. Enjoy!

- para_server: fix hang on song change and crash on sighup.
  Speed up mysql queries. The DIR_LIKE macro is gone.
- new executables: para_audiod, the local audio daemon that
  starts playback (uses SCM_CREDENTIALS socket magic) and
  para_audioc, the corresponding client.
- new executables: para_mp3dec/para_oggdec, two really teensy
  decoders. para_mp3dec is based on libmad, para_oggdec requires
  libvorbisfile.
- ovsend/ovrecv are capable of streaming ogg as well as mp3, so
  they are now called para_send and para_recv respectively.
- documentation updates
- para_gui is themable. For now there is the default theme that
  looks as before and the simple theme: blue and easy.
- gui: audio streaming is now handled by audiod. Time display shows
  playback time rather than streaming time
- slider: update to libzmw-0.2.0
- para_krell: fix crash on server shutdown
- switch from gzip to bzip2

----------------------------------------
0.1.7 (2005-04-18) "melting penetration"
----------------------------------------

The main change in this release is clearly the oggvorbis rewrite,
but there are also lots of smaller changes. If you intend to use both
the mp3 and the ogg plugin, it is recommended to use software mixing,
e.g. the dmix plugin which is provided by ALSA.

- new executables: para_ovsend and para_ovrecv for sending/receiving
  oggvorbis files via rtp. Requires the open rtp library. Get it at
  http://www.linphone.org/ortp/
- rewrite of the ogg_vorbis core code
- configure detects libzmw and, if detected, includes
  para_slider to the list of binaries to be built by make
- server stream writers read from their associated fifo rather
  than from stdin
- slider: two new sliders, lastplayed and numplayed
- fix nasty double free bug which caused random segfaults in case of
  mp3 files with invalid header information
- gui: new command line option: --stream_timeout=seconds  to
  deactivate a slot if it is idle for that many seconds (default=`5')
- diffstats

---------------------------------------
0.1.6 (2005-03-05) "asymptotic balance"
---------------------------------------

Only little user-visible changes in this release. Mainly bugfixes and
core code cleanup. This is probably the most stable version ever if you
stick to mp3...

- fix several memory leaks
- rename default name of mysql database from "music" to "paraslash".
  Use para_server's  --mysql_database option if you do not want to
  rename your old database.
- rework ogg vorbis code
- make update command work on mysql servers with LOCAL_INFILE
  disabled
- gui: improved stream I/O (slots)
- simplified audio format API
- para_pob_ogg is gone

------------------------------------
0.1.5 (2004-12-31) "opaque eternity"
------------------------------------

Let's slide gently into the new year.

- new: para_slider (not built automatically, type "make
  para_slider" to build). A toy for those who always felt that
  creating stream definitions is difficult. See screenshots,
  README and FEATURES for more info.
- improved signal handling. Fixes server segfault on SIGHUP
  for linux kernels newer than Aug 24 2004 and makes para_gui
  race-free.
- reload database tool on SIGHUP
- improved help message for sl
- do not log "broken pipe" messages as errors. They are
  perfectly ok.
- fix wrong error message on permission errors

-----------------------------------------
0.1.4 (2004-12-19) "tunneling transition"
-----------------------------------------

Bugfix release. As expected, 0.1.3 introduced a bunch of new bugs.
Hopefully, most of them got wiped out with this release. Some
enhancements went also in.

- improved error diagnostics for all commands
- stradd/picadd: overwrite previous contents if entry already
  exists, rather than returning errors
- stradd: use current stream if invoked without args
- faster (and hopefully more stable) ogg-vorbis handling
- para_krell: reap children to avoid zombie-flooding in case
  no server is running
- si: report also server pid
- server: don't busy-loop if dbtool reports only invalid files.
- gui: CTRL+C works again, fix stream_read command line option
- fix pic_add, hist
- fix mysql dbtool startup in case no database exists
- many small fixes and cleanups

---------------------------------------
0.1.3: (2004-12-10) "vanishing inertia"
---------------------------------------

Starting from this release, the database tools are integrated in the
server binary. This decreases server startup time, reduces code size
and speeds up database commands. However, the layout of the underlying
mysql database changed only slightly and 0.1.3 should be backwards
compatible in that respect.

Visible changes:

- If mysql is not detected at compile time, or fails to init
  at runtime, fall back to the dopey database tool which should
  always work.
- para_dbtool and dbtool.conf are gone. All mysql specific
  options are read from server.conf and are prefixed by 'mysql_'.
- new command: cdt (change database tool)
- new command line option: dbtool (choose startup database tool)
- The name of current stream is now stored in the database,
  so paraslash remembers its current stream when restarted.
- new command: csp (change stream and play)
- para_gui also reports current database tool and server uptime

-------------------------------------------
0.1.2: (2004-11-28) "spherical fluctuation"
-------------------------------------------

Point release before the big dbtool changes go in.

- dbtool: rename ca to cam (copy all meta data). It now also
  copies numplayed and lastplayed time as well as the picture
  id.
- fix endless-loop-bug caused by mp3 files with invalid header

-----------------------------------------
0.1.1: (2004-11-05) "floating atmosphere"
-----------------------------------------

- gkrellm plugin
- new dbtool command: mbox. Browse your sound-file collection
  with your favorite mail reader.
- several small fixes

-------------------------------------
0.1.0: (2004-10-22) "rotating cortex"
-------------------------------------

- fix logging bug for loglevel > VERBOSE
- fix skip command
- correct timings for vbr mp3s
- modular audio format support
- ogg-vorbis support (experimental)
- new server option: autoplay

-----------------------------------------
0.0.99: (2004-07-25) "harmonic deviation"
-----------------------------------------

- rename projectname from icc to paraslash (play, archive, rate
  and stream large audio sets happily)
- paraslash is no longer restricted to one particular audio
  streaming software
- new dbtool commands (stradd, strq, strdel) for easy stream
  managment w/o configuration file. That obsoletes stream_defs
  file/config option for dbtool.
- picadd accepts jpeg data from stdin
- new server commands: ps (select previous stream), sc (song change)
- new default pictures for sdl_gui
- gui: new key_map option for binding commands and internal
  functions to arbitrary keys, nice help screen, rip out
  soundcard/linux specific stuff, avoid noise artefacts while jumping,
  show silly logo on startup
- new executables: para_fade for fading volume, para_dbadm for
  manipulating attributes
- cdb adds _all_ tables to mysql database
- revised and beautified documentation
- sample dbtool rewritten in C
- autoconf

---------------------------------------------
0.0.98: (2003-12-26) "incremental smoothness"
---------------------------------------------

- kick icecast in favour of poc. That removes some races and reduces
  core code considerably.
- cbr/vbr is displayed by stat and gui/sdl_gui. New status flags
  give finer info on afs' status.
- gui can start decoder (see config options). Further new gui
  commands: refresh (^L), jmp (F1-F10)
- gui rereads conf on SIGUSR1 instead of SIGHUP. SIGHUP
  terminates gui. This fixes dead instances consuming memory
  continuously.
- new dbtool command: verb for sending verbatim sql queries.
- fix pid_list races (by removing pid_list)
- codename funnies

--------------------
0.0.97: (2003-10-26)
--------------------

- installation prefix now defaults to /usr/local
- new commands for gui: snozze, sleep and reread config
- config file for gui and sdl_gui
- fix problems with filenames containing funny characters
  (reported by Thomas Forell)
- improved signal handling for gui, now it rereads conf on SIGHUP
- new dbtool command: cdb (create database)
- switch from argtable to gengetopt
- major code cleanup and speed improvements
- fix several potential buffer overflows
- many small fixes and cleanups

-------------------
0.0.96 (2003-08-30)
-------------------

- easy stream_defs syntax
- sdl_gui can display images associated to the file being played
- Major feature enhancements for icc_gui including dynamic text
  placement and the top/bottom window design
- vrfy/clean now also checks for NULL values in attributes as
  well as for invalid picture pointers
- fix long outstanding case sensitivity bug
- many small fixes and cleanups

-------------------
0.0.95 (2003-06-29)
-------------------

- sdl gui runs much faster
- new dbtool command: ca (copy attributes)
- count and display number of times the song has been played
- new feature: scoring
- command line options for sdl_gui
- simpler syntax of streams file
- decrease network traffic of stat
- fix zombie bug
- many small fixes and cleanups

-------------------
0.0.94 (2003-05-04)
-------------------

- new server command: ns (next stream)
- new icc_gui command: c (change stream)
- internal mp3info
- stat shows also id3 tag info
- new sdl based gui
- log flodding bug fixed
- many small fixes and cleanups

-------------------
0.0.93 (2003-03-28)
-------------------

- colors for icc_gui
- icc_gui sets volume directly (linux only)
- proper locking that fixes some races
- fix security bug that caused commands to be executed even
  with unsufficient permissions
- new command: hup to make all servers reread their configuration file
- icecast meta data streaming
- many small fixes and cleanups
